#include <p32mz0512efe064.h> 

/*	http://ww1.microchip.com/downloads/en/DeviceDoc/61107G.pdf	*/	
    
/*** DEVCFG0 ***/
	
.section .config_BFC0FFCC,code
.word 0xFFFFF7FF

/*** DEVCFG1 ***/

.section .config_BFC0FFC8,code
.word	0x5FF4FF39

/*** DEVCFG2 ***/

.section  .config_BFC0FFC4, code
.word	0xFFF9B198

/*** DEVCFG3 ***/

.section  .config_BFC0FFC0, code
.word	0x84FFFFFF

# .section .config_BFC0FFC8,code
# .word	0x5FF4FF39

/*** DEVCFG2 ***/
	
.equ	UTXBF,0x200	    # 9 bit	
.equ	URXDA,0x001	    # 0 Bit
.equ	OERR, 0x002	    # 1 Bit
.equ	TRMT, 0x100	    # 8 bit

# ???? ??????? ??????:
        .section        .bss
        .size   uart_buf, 1028
uart_buf:
        .space  1028
	
.global main

	.data

msgPrompt:	 .ascii	    "frt>\000"

   	.text

/***************************************************************/

	.ent    main
main:

	jal	UART1_Init
        jal	DisplayPrompt
	
fr:	
	jal	get_char
	jal	out_char 

	j	fr

	.end	main

/***************************************************************/
	
	.ent	Delay100us

Delay100us:
    
    	addiu	$sp, $sp, -4
	sw	$a0, 0($sp)
	li      $a0,260
	
l100us:
    
	addiu   $a0,$a0,-1
	bne     $a0,$0,l100us
	lw	$a0, 0($sp)
	addiu	$sp, $sp,4
	jr	$ra
	
	.end	Delay100us

/***************************************************************/

	.ent	UART1_Init

UART1_Init:

	addiu	$sp, $sp, -4
	sw	$a0, 0($sp)

        ll	$t2,TRISD
	and     $t2,0xFFFFF7FF      # 45/RD11 Set ISO3088 to receive state.
	sw      $t2,TRISD

	ll	$t2,LATD
	and     $t2,0xFFFFF7FF      # Set ISO3088 to receive state.
	or      $t2,0x00000800      # Set ISO3088 to send state.
	sw      $t2,LATD

	ll	$t2,TRISC
	or      $t2,0x00004000	    # RC14 Input
	and	$t2,0xFFFFDFFF	    # RC13 Output
	sw	$t2,TRISC

	ll	$t2,LATC
	or      $t2,0x6000
	sw      $t2,LATC

	lw      $t2,RPC13R
	or      $t2,0x0001	    # U1TX on RPC13
	sw      $t2,RPC13R

	lw      $t2,U1RXR
	ori     $t2,0x0007	    # U1RX on RPC14
	sw      $t2,U1RXR	   

	li      $t2,650		    # U1BRG = (FPb/(16*baud))-1
	sw      $t2,U1BRG	    # U1BRG = 100000000/(16*9600)-1 = 650

	li      $t2,0x8000	    # Enable UART for 8-bit data
	sw      $t2,U1MODE

	li      $t2,0x1400	    # Enable Transmit and Receive
	sw      $t2,U1STA	    # 0x00010000

	ll      $t2,IFS3	    
	and	$t2,0xFFF9FFFF
	sw      $t2,IFS3

	lw	$a0,0($sp)
	addiu	$sp,$sp,4
	jr	$ra

	.end	UART1_Init

/***************************************************************/
	
	.ent	DisplayPrompt

DisplayPrompt:

	addiu	$sp, $sp, -4
	sw	$a0, 0($sp)
	la      $t0,msgPrompt
	
.nextByte:

        ll      $t1,U1STA	       # U1STA ????????? Busy Flag (BF)
        andi    $t1,$t1,UTXBF
        bne     $t1,$zero,.nextByte    # ???? ?????????? ?????? ?? ?????????, ????

	lb      $a0,($t0)
	beqz	$a0,endString

	sb      $a0,U1TXREG	    # U1STA Busy Flag (BF)
	addu 	$t0,1

.waitTransmit:	
    
	ll      $t1,U1STA	    # U1STA ????????? Busy Flag (BF)
        andi    $t1,$t1,TRMT	    #
        beq     $t1,$zero,.waitTransmit

	j	.nextByte

endString:
    
	lw	$a0,0($sp)
	addiu	$sp,$sp,4

	jr	$ra

	.end	DisplayPrompt

/***************************************************************/	

	.ent	get_char

get_char:

	ll	$t0,LATD
	and     $t0,0xFFFFF7FF      # Set ISO3088 to receive state.
	sw      $t0,LATD

.RXCHR:	lw      $t0,U1STA	    # U1STA ????????? Busy Flag (BF)
	andi    $t0,$t0,0x001	    # 0x001
	beq     $t0,$zero,.RXCHR    # ???? ?????? ?? ???????, ????

/*	
.OERR:	ll      $t0,U1STA	    # U1STA ????????? Busy Flag (BF)
	andi    $t0,$t0,OERR	    # 0x200
	bne     $t0,$zero,.OERR	    # ???? ?????????? ?????? ?? ?????????, ????
*/

	lb      $a0,U1RXREG

	jr	$ra
	
	.end	get_char

/***************************************************************/	

	.ent	out_char
	
out_char:

	ll	$t0,LATD
	or      $t0,0x00000800      # Set ISO3088 to send state.
	sw      $t0,LATD

.TXCHR:	ll      $t0,U1STA	    # U1STA ????????? Busy Flag (BF)
        andi    $t0,$t0,0x200	    
        bne     $t0,$zero,.TXCHR    # ???? ?????????? ?????? ?? ?????????, ????

	sb      $a0,U1TXREG	    # U1STA Busy Flag (BF)

.LTRMT:	ll      $t0,U1STA	    # U1STA ????????? Busy Flag (BF)
        andi    $t0,$t0,TRMT	    
        beq     $t0,$zero,.LTRMT    # ???? ?????????? ?????? ?? ?????????, ????
	
	jr	$ra
	
	.end	out_char
	
	

/***************************************************************/	
	
/*  UART Communication: 
	
    https://www.cnblogs.com/geekygeek/p/pic32mz_uartcommunication.html 
	
    Computer Organization with MIPS: 
	
     https://rdw.rowan.edu/cgi/viewcontent.cgi?article=1008&context=oer	    

    ???????? ?????????? ?? PIC32:

    http://we.easyelectronics.ru/PIC/izuchenie-assemblera-na-pic32-com-buferizovannaya-zapis.html
	
	
    PIC32MZ EXAMPLES:

    https://github.com/eziya/PIC32MZ_EXAMPLES

*/  
	